KeyLoop:
	tst.b		Update				;<-- Is it time to update our clock?
	beq		\KeyContinue			;<-- If not, continue on.
	jsr		DispSec				;<-- If so, "Display the Seconds"
	move.b 	#0,Update				;<-- Reset the Update flag
\KeyContinue
	tst.w		(doorsos::kb_vars+$1c)
	beq		KeyLoop
	move.w	(doorsos::kb_vars+$1e),d0
	clr.w		(doorsos::kb_vars+$1c)	;<<*** DON'T FORGET TO CLEAR $1c not $1e
	cmp.w		#264,d0
	beq		Start
	cmp.w		#KEY_UP,d0
	beq		\Up
	cmp.w		#KEY_DOWN,d0
	beq		\Down
	cmp.w		#KEY_LEFT,d0
	beq		\Left
	cmp.w		#KEY_RIGHT,d0
	beq		\Right
	cmp.w		#120,d0
	beq		\TestBlock
	cmp.w		#121,d0
	beq		\FlagBlock
	cmp.w		#91,d0
	beq		\AutoWin
	bra		KeyLoop

\Up
	cmp.w		#16,CurY
	beq		KeyLoop
	move.w	CurX,OldX
	move.w	CurY,OldY
	sub.w		#8,CurY
	jsr		Block
	bra 		KeyLoop

\Down
	cmp.w		#88,CurY
	beq		KeyLoop
	move.w	CurX,OldX
	move.w	CurY,OldY
	add.w		#8,CurY
	jsr		Block
	bra 		KeyLoop

\Left
	cmp.w		#16,CurX
	beq		KeyLoop
	move.w	CurX,OldX
	move.w	CurY,OldY
	sub.w		#8,CurX
	jsr		Block
	bra 		KeyLoop

\Right
	cmp.w		#136,CurX
	beq		KeyLoop
	move.w	CurX,OldX
	move.w	CurY,OldY
	add.w		#8,CurX
	jsr		Block
	bra 		KeyLoop

\TestBlock
	move.w	CurX,d0
	sub.w		#16,d0
	divu.w	#8,d0
	move.w	d0,BlkX
	move.w	CurY,d0
	sub.w		#16,d0
	divu.w	#8,d0
	move.w	d0,BlkY
	jsr		BombCount
	tst.b		WinFlag
	bgt		Won
	blt		Lost
	bra 		KeyLoop

\FlagBlock
	move.w	CurX,d0
	sub.w		#16,d0
	divu.w	#8,d0
	move.w	d0,BlkX
	move.w	CurY,d0
	sub.w		#16,d0
	divu.w	#8,d0
	move.w	d0,BlkY
	jsr		Flag
	tst.b		WinFlag
	bgt		Won
	blt		Lost
	bra		KeyLoop

\AutoWin
	bra		Won

Wait:
	tst.w		(doorsos::kb_vars+$1c)
	beq		Wait
	clr.w		(doorsos::kb_vars+$1c)
	rts
