	include "DoorsOS.h"
	include "Userlib.h"
	include "Graphlib.h"

	;*** ALL NON-STANDARD (aka. self-made) INCLUDES
	;*** ARE AT THE BOTTOM OF THE FILE EXCEPT:

	include "MineMacros.asm"

	xdef _main
	xdef _comment
	xdef _ti89

_main:
	
	;**** Tells people who wrote this program	****
	;**** aka splash screen. It's way up here 	****
	;**** so that it will only be accessed 	****
	;**** once by the program - at start up.	****

	jsr		ClearScreen			;<-- Clears the screen for use by JonMine
	String	#2,#38,#26,#2,StrAbout1	;<-- Shows the Splash Screen
	String	#2,#55,#26,#2,StrAbout2	;<-- Shows the Splash Screen
	jsr		Wait					;<-- Wait for key press

	;**** Continue with program after the	 ****
	;**** Splash Screen				 ****

	jsr		TimerSetup				;<-- Insert our timer

Start:
	jsr		ClearScreen			;<-- Clear the Screen
	jmp		MainMenu				;<-- Goto main menu

Ending:
	jsr		TimerRemoval			;<-- Remove our timer code
	rts


;****** INCLUDES ******	
	include "MineGraphics.asm"
	include "MineKeyboard.asm"
	include "MineLevelIO.asm"
	include "MineTimer.asm"
	include "MineMenu.asm"
	include "MineTiles.asm"
	include "MineVars.asm"
	end ;of file
